EaBIM

标题: 拷贝Revit中的对象的诀窍,顺论Revit中对象的拷贝 [打印本页]

作者: 萧闫子    时间: 2014-1-15 12:48
标题: 拷贝Revit中的对象的诀窍,顺论Revit中对象的拷贝
我以前有一篇文章讲到可以使用Duplicate() 方法在Revit中,如何编程创建新类型(如窗户或墙) 。 顺便说一句在以后Revit(> 2012)的类型对象复制中,慢慢从类型对象的类里面增加Create() 函数替代原来的Dupicate方法。
这个方法只是局限于类型对象。Revit的对象种类很多,比如视图中可见对象,不可见的对象。如何从这些对象中拷贝创建新对象呢?

在Revit2012, 提供了ElementTransformUtils类用于移动,镜像,旋转,复制对象。 从这几个方法看,好像这个类只能对可见的Revit对象或者是具有几何表达的对象进行操作。因为包含了镜像,移动。 所以比较容易理解其中的CopyElement()方法也只能对可见对象进行复制。
实际上这个CopyElement() 方法也可以对不可见的对象进行复制,比如下面的代码复制已有的视图的模板,view template。这个是定义视图的一些属性,可以在多个视图中共用其中的属性设置。
请看下面的代码:

  1. [csharp] view plaincopy
  2. using System;  
  3. using System.Collections.Generic;  
  4. using System.Text;  
  5. using System.Windows.Forms;  
  6.   
  7. using  Autodesk.Revit .DB;  
  8. using Autodesk.Revit.UI;  
  9. using Autodesk.Revit .ApplicationServices;  
  10. using Autodesk.Revit.Attributes ;  
  11.   
  12.   
  13.   
  14.   [TransactionAttribute(Autodesk.Revit.Attributes.TransactionMode.Manual)]  
  15. public class RevitCommand : IExternalCommand  
  16. {  
  17.     public Result Execute(ExternalCommandData commandData, ref string messages, ElementSet elements)  
  18.     {  
  19.   
  20.       UIApplication app = commandData.Application;  
  21.       Document doc = app.ActiveUIDocument.Document;  
  22.   
  23.       //get the plan view template  
  24.   
  25.       FilteredElementCollector collector = new FilteredElementCollector(doc);  
  26.       collector.OfClass(typeof(ViewPlan));  
  27.   
  28.       Autodesk.Revit.DB.View template = null;  
  29.       foreach (Element elem in collector)  
  30.       {  
  31.         Autodesk.Revit.DB.View view = elem as ViewPlan;  
  32.         if (view.IsTemplate)  
  33.         {  
  34.           template = view;  
  35.           break;  
  36.         }  
  37.       }  
  38.         
  39.       Transaction trans = new Transaction(doc, "ExComm");  
  40.       ICollection<ElementId> cols = null;  
  41.       try  
  42.       {  
  43.         trans.Start();  
  44.   
  45.         //29485  
  46.         XYZ vector = new XYZ(0, 0, 1);  
  47.         cols = ElementTransformUtils.CopyElement(doc, template.Id, vector);  
  48.   
  49.         trans.Commit();  
  50.       }  
  51.       catch(Exception ex)        
  52.       {  
  53.         MessageBox.Show(ex.Message,"test");  
  54.       }  
  55.   
  56.       MessageBox.Show(cols.Count.ToString());  
  57.   
  58.       return Result.Succeeded ;  
  59.     }  
  60. }  
复制代码

但是这篇文章并没有完全测试所有的对象的拷贝,请使用时测试下是否可行。如果碰到不可行的对象,请在本文追加说明。这样大家都知道了。
作者:叶雄进文章来源:http://blog.csdn.net/joexiongjin/article/category/782739



作者: 乖乖仔    时间: 2014-2-20 14:11
(*^__^*) 嘻嘻……




欢迎光临 EaBIM (https://eabim.net/) Powered by Discuz! X3.2